
public class Lanczos{
	public static double[][] q;
	public static boolean verbose = false;
    
	public static void main(String args[]){
		
        double [][] A = {{1,1,3,0,1,1,2},
        				 {1,2,1,1,2,1,0},
        				 {3,1,4,3,0,2,1},
        				 {0,1,3,1,1,0,1},
        				 {1,2,0,1,1,1,0},
        				 {1,1,2,0,1,1,2},
        				 {2,0,1,1,0,2,2}};
        
    	
	    int n = A.length;
	    double[][] I = new double[n][n];
        q = new double[n][];
        
        int i = 0;
        for(i = 0; i < n; i++)
	        for(int j = 0; j < n; j++)
	        	I[i][j] = (i == j) ? 1 : 0;

        System.out.println("Starting Matrix");
        printM(A);
        
        A = lanczos(A); 
        System.out.println(" ");
        System.out.println("Generating a tri-diagonal matrix");
        printM(A);
       
    }
     
    public static double[][] lanczos(double[][] M)
	{
		int n = M.length;
	    double [][] temp = new double[1][n];
        double[] b = new double[n+1];
        double[] a = new double[n+1];
        double[][] I = new double[n][n];
        double[] zeroVector = zerorize(n);
	    double[] columnVector;
	    double[][] lanczosM = new double[n][];
	   
	    int i = 0;
        for(i = 0; i < n; i++)
	        for(int j = 0; j < n; j++)
	        	I[i][j] = (i == j) ? 1 : 0;
        
        //considering index 0 as 1
        i=0;
        b[0] = 0;
        q[0] = zerorize(n);
        q[0][0] = 1; 
        
        a[0] = dot(q[0],matrixVectorMultiplication(M,q[0]));
        temp[0] = vectorMinus(matrixVectorMultiplication(M,q[0]), vectorScalarMultiplication(q[0],a[0]));
        
        b[0] = Math.sqrt(dot(temp[0],temp[0]));
        q[1] = vectorScalarMultiplication(temp[0],1/b[0]);
        i++;
        
        
        while(i<n-1) // if n, index out of bound
	    {
	    	a[i] = dot(q[i],matrixVectorMultiplication(M,q[i]));
	        temp[0] = vectorMinus(vectorMinus(matrixVectorMultiplication(M,q[i]), vectorScalarMultiplication(q[i-1],b[i-1])) ,vectorScalarMultiplication(q[i], a[i]));  
	        b[i] = Math.sqrt(dot(temp[0],temp[0]));
	        q[i+1] = vectorScalarMultiplication(temp[0],1/b[i]);
	        i++;
	     }
	    
	    a[i] = dot(q[i],matrixVectorMultiplication(M,q[i]));
	       
	    //constructing return
	    //initial
	    i = 0;
	    int k=0; 
	    columnVector = (double[]) zeroVector.clone();
	    columnVector[i] = a[k];
	    columnVector[i+1] = b[k];
	    lanczosM[i] = columnVector;
	        
	    //mid
	    i++;
	    k++;
	    while(i<n-1) 
	    {
	    	columnVector = (double[]) zeroVector.clone();
	        columnVector[i-1] = b[k-1];
	        columnVector[i] = a[k];
	        columnVector[i+1] = b[k];
	        lanczosM[i] = columnVector;
	        i++;
	        k++;
	     }
	        
	    //end
	    columnVector = (double[]) zeroVector.clone();
	    columnVector[i-1] = b[k-1];
	    columnVector[i] = a[k];
	    lanczosM[i] = columnVector;
	    
	    return lanczosM;
	}
    
    public static double[][] copy(double [][] temp) 
	{
	
		double [][] m = new double[temp.length][temp[0].length];
		for (int i = 0; i < temp.length; i++) 
		{
	      for (int j = 0; j < temp[0].length; j++) 
	      {
	    	  m[i][j] = temp[i][j];
	      } 
	    } 
		return m;
	}

   
    public static double dot(double[] u, double[] v)
    {
        int n = v.length;
        double sum = 0;
        for(int i=0; i<n; i++)
        	sum = sum + u[i]*v[i];
        
        return sum;
    }

    public static double[][] transpose(double[][] M)
    {
        int n = M.length;
        int m = M[0].length;
        double[][] A = new double[n][m];
        
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                A[j][i] = M[i][j];
        return A;
     }

    public static double[] vectorPlus(double[] u, double[] v)
    {
        int n = u.length;
        double[] A = new double[n];
        for(int i=0; i<n; i++)
        {
        	A[i] = u[i] + v[i];
            i++;
        }
        return A;
    }

    public static double[][]  matrixMinus(double[][] M, double[][] N)
    {
        int n = M.length; 
        double[][] A = new double[n][];
        for(int i=0; i<n; i++)
        {
            A[i] = vectorMinus(M[i],N[i]);
            i++;
        }
        return A;
    }

    public static double[] vectorMinus(double[] u, double[] v)
    {
        int n = u.length;
        double[] A = new double[n];
        for(int i=0; i<n; i++)
        {
        	A[i] = u[i] - v[i];
        }
        return A;
    }

    public static double[] vectorScalarMultiplication(double[] v, double k)
    {
        int n = v.length; 
        double[] A = new double[n];
        for(int i=0; i<n; i++)
        {
            A[i] = v[i]*k;
           
        }
        return A;
    }

    public static double[][] matrixMultiplication(double[][] M, double[][] N)
    {
        int n = M.length; 
        int m = N.length;
        double[][] A = new double[m][];
        for(int i=0; i<n; i++)
        {
        	A[i] = matrixVectorMultiplication(M,N[i]);
       
        }
        return A;
    }

    public static double[] matrixVectorMultiplication(double[][] M, double[] v)
    {
        int n = M.length; 
        int m = M[0].length;
        double[] x = new double[n];
      
        for(int i=0; i<m; i++)
        {
        	for(int j=0; j <n; j++)
        	{
        		x[i] = x[i]+M[j][i]*v[j];
        		if (Double.parseDouble(String.format("%.3f",x[i])) == -0.000f)  
        			x[i]= 0.000f;
        	}
        	
        }
        return x;
    }

   
    public static double[] zerorize(int n)
	{
		double[] z = new double[n];
	    for(int i = 0; i<n;i++)
	    	z[i] = 0;
	    return z;
	}

    public static void printM(double[][] M)
	{
    	 for(int i=0; i<M.length; i++)
         {
         	for(int j=0; j <M[0].length; j++)
         	{
	    		System.out.print(String.format("%.3f",M[i][j]) + " ");
	        }
	        
	    	System.out.println("  ");
	     }
	}
}


